<?php
namespace Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DTO\Response\Error;

class Fai38000LancamentoFaturamentoDiversosController extends \Teknisa\Libs\Controller\CRUD {

	
	protected $dataSourceName;
	protected $dataSourceNameToSave;
	protected $connection;
	protected $dataSourceManager;
	protected $environment;

	public function __construct($crudService, $environment, $dataSourceManager, $connection){
		$this->dataSourceManager = $dataSourceManager;
		$this->crudService 		 = $crudService;
		$this->connection		 = $connection;
		$this->environment       = $environment;
	}
	
	
	public function atualizaFaturamentoDiversos(DTO\Request $request, DTO\Response $response){
        $dataSet = $request->getDataSet("DataSet");
        
        $rows = $dataSet->getRows();
        
        if($dataSet != null){
        	
        	$rows = $dataSet->getRows();
        	
        	foreach ($rows as $row) {
        	
	            $impostoBackupRow   = $row[0];
	            $impostoCurrentRow  = $row[1];
	            
	            
	            try{
	                $stmt = $this->connection->prepare(
	                	"UPDATE LANCFATUDIVE
						    SET DTLANCFATDIV = :P_DATA_LANCAMENTO,
						        VRLANCFATDIV = :P_VALOR
						  WHERE CDFILIAL     = :P_CDFILIAL     AND
						        CDFATUDIVER  = :P_CDFATUDIVER  AND
						        DTLANCFATDIV = :P_DTLANCFATDIV"
	                	);
	    
	                $stmt->execute(
	                    array(
	                        'P_DATA_LANCAMENTO' => $impostoCurrentRow["DTLANCFATDIV"],
	                        'P_VALOR'           => $impostoCurrentRow["VRLANCFATDIV"],
	                        'P_CDFILIAL'        => $impostoBackupRow["CDFILIAL"],
	                        'P_CDFATUDIVER'     => $impostoBackupRow["CDFATUDIVER"],
							'P_DTLANCFATDIV'    => $impostoBackupRow["DTLANCFATDIV"],
	                    )
	                );
	            }catch(\Exception $ex){

	                if(strpos($ex->getMessage(), "ORA-00001") === FALSE){
	                    $response->setError(new Error($ex->getMessage(), 500));
	                }else{
	                    $response->setError(new Error("DUPLICIDADE", 500));
	                }
	            }
        	}
        }
    }
}