/* Sistemas Integrados TEKNISA

Nome: 9503_CVIIEO_ETL_CONTAPAGDTVENC
Descrio: view que retorna AS CONTAS A PAGAR EM ABERTO POR DATA DE VENCIMENTO DO BOLETO (ANO E MES)

Criao:
24/07/2012 - Ftima Fernandes
*/

CREATE OR REPLACE FORCE VIEW "DM_CONTAPAGDTVENC" ("CDEMPRESA", "CDFILIAL", "NMFILIALRECE", "NMFANTFORN", "NMRAZSOCFORN", 
"NMTIPOCONTA", "CDANOBI", "CDMESBI", "DSSTCONTA", "STATUS", "DOC_SERIE", "DESCRICAO","VRBRUTOBOLETOPAG", "VRLIQUIDOBOLETOPAG", "VRAJUSTEBOLETOPAG",
 "VRORIGCTPAG", "VRAJUSTECTPAG", "VALORAPAGAR", "QTCONTAS", "QTDIASVENCTO", "QTDIASATRASO", "QTBOLEMATRASO")
AS
(SELECT  BO.CDEMPRESA, BO.CDFILIAL, F.CDFILIAL || '_' || F.NMFILIAL AS NMFILIALRECE,
        FO.NMFANTFORN, FO.NMRAZSOCFORN,
        CT.CDTPCTPAGAR|| '-' || DSTPCTPAGAR AS NMTIPOCONTA,
        TO_CHAR(BO.DTVENBOLPAG, 'YYYY') AS CDANOBI,
        TO_CHAR(BO.DTVENBOLPAG, 'MM') AS CDMESBI,
        DECODE (NF.IDSTATUS,'V','PREVISTA','REAL') AS DSSTCONTA,
        (CASE WHEN TRUNC(BO.DTVENBOLPAG) < TRUNC(SYSDATE) THEN 'VENCIDA' ELSE 'A VENCER'END) STATUS,
        (NF.NRNOTAFISC||'/'||NF.CDSERIEENTR||' - Venc.:'||BO.DTVENBOLPAG) DOC_SERIE,
        (CT.DSCONTAPAG) DESCRICAO,
        (ROUND(BO.VRBOLPAG, 2)) AS VRBRUTOBOLETOPAG,
        (ROUND(BO.VRFINALBPAG, 2)) AS VRLIQUIDOBOLETOPAG,
        (ROUND(BO.VRFINALBPAG, 2) - ROUND(BO.VRBOLPAG, 2)) AS VRAJUSTEBOLETOPAG,
        SUM(ROUND(CT.VRORIGPAG, 2)) AS VRORIGCTPAG,
        SUM(ROUND(CT.VRATUAPAG,2) - ROUND(CT.VRORIGPAG,2)) AS VRAJUSTECTPAG,
        SUM (ROUND(CT.VRATUAPAG,2)  + ((ROUND(BO.VRFINALBPAG,2) - ROUND(BO.VRBOLPAG,2)) * (ROUND(CT.VRATUAPAG,2)/ROUND(BO.VRBOLPAG,2)))) AS VALORAPAGAR,
        COUNT(*) AS QTCONTAS,
        TRUNC(BO.DTVENBOLPAG) - TRUNC(NF.DTENTRSAID) AS  QTDIASVENCTO,
        (CASE WHEN TRUNC(BO.DTVENBOLPAG) < TRUNC(SYSDATE) THEN ROUND(TRUNC(SYSDATE) - TRUNC(BO.DTVENBOLPAG))  ELSE 0  END) QTDIASATRASO,
        (CASE WHEN TRUNC(BO.DTVENBOLPAG) < TRUNC(SYSDATE) THEN 1 ELSE 0 END) QTBOLEMATRASO
FROM CONTAPAGAR CT, BOLETPAGAR BO, FORNECEDOR FO, TIPOCTPAGAR TP, NOTAFISCAL NF, FILIAL F
WHERE    BO.CDFILIAL(+)    = CT.CDFILIBPAG 
     AND BO.NRLANBOLPAG(+) = CT.NRLANBOLPAG
     AND CT.VRATUAPAG <> 0
     AND CT.IDSTATPAG ='A'
     AND FO.CDFORNECED = BO.CDFORNECED
     AND TP.CDTPCTPAGAR = CT.CDTPCTPAGAR
     AND CT.NRLANCTONF = NF.NRLANCTONF
     AND F.CDFILIAL    = NF.CDFILIRECE
     AND CT.CDFILIAL   = NF.CDFILIAL
GROUP BY BO.CDEMPRESA, BO.CDFILIAL, F.CDFILIAL, F.NMFILIAL, 
     FO.NMFANTFORN, FO.NMRAZSOCFORN, CT.CDTPCTPAGAR,  CT.DSCONTAPAG,DSTPCTPAGAR,  
     NF.IDSTATUS, BO.VRBOLPAG, BO.VRFINALBPAG, BO.DTVENBOLPAG,NF.DTENTRSAID,NF.NRNOTAFISC,NF.CDSERIEENTR)
/
BEGIN
--Fatos--
	CRIA_FATOS('DM_CONTAPAGDTVENC', 'QTCONTAS'   		,'Qt. de Contas'			,'Quantidade de contas'		      ,'Contas Pagas - Data de Venc.');
	CRIA_FATOS('DM_CONTAPAGDTVENC', 'VRBRUTOBOLETOPAG'  ,'Vr. Bruto dos Boletos'			,'Valor Bruto do Boleto'	      ,'Contas Pagas - Data de Venc.');
	CRIA_FATOS('DM_CONTAPAGDTVENC', 'VRLIQUIDOBOLETOPAG','Vr. Lq. dos Boletos'			,'Valor Lquido do Boleto'	      ,'Contas Pagas - Data de Venc.');
	CRIA_FATOS('DM_CONTAPAGDTVENC', 'VRAJUSTEBOLETOPAG'	,'Vr. de Ajuste dos Boletos'		,'Valor de Ajuste do Boleto'	      ,'Contas Pagas - Data de Venc.');
	CRIA_FATOS('DM_CONTAPAGDTVENC', 'VRORIGCTPAG'		,'Vr. Inic. das Contas Pag.'		,'Valor Inicial da Conta a pagar'	      ,'Contas Pagas - Data de Venc.');
	CRIA_FATOS('DM_CONTAPAGDTVENC', 'VRAJUSTECTPAG'		,'Vr. de Ajuste Contas a Pagar'		,'Valor de ajuste da Conta a Pagar'		      ,'Contas Pagas - Data de Venc.');
	CRIA_FATOS('DM_CONTAPAGDTVENC', 'VALORAPAGAR'		,'Vlr. a Pagar'				,'Valor a Pagar'		      ,'Contas Pagas - Data de Venc.');
	CRIA_FATOS('DM_CONTAPAGDTVENC', 'QTDIASVENCTO'		,'Dias para o Venc.'			,'Quantidade de Dias para o venc.'    ,'Contas Pagas - Data de Venc.');
	CRIA_FATOS('DM_CONTAPAGDTVENC', 'QTDIASATRASO'		,'Dias em Atraso.'			,'Quantidade de Dias em o Atraso'     ,'Contas Pagas - Data de Venc.');
	CRIA_FATOS('DM_CONTAPAGDTVENC', 'QTBOLEMATRASO'    	,'Quant. de Bole. em atraso'		,'Quantidade de Boleto em o Atraso'   ,'Contas Pagas - Data de Venc.');
	
		
--Dimenso--	
	CRIA_DIME('DM_CONTAPAGDTVENC'	,'CDEMPRESA'	,'Empresa'			,'EMPRESA','CDEMPRESA'	  ,'NMEMPRESA'	  ,NULL);
	CRIA_DIME('DM_CONTAPAGDTVENC'	,'CDFILIAL'	,'Filial'			,'FILIAL' ,'CDFILIAL' 	  ,'NMFILIAL' 	  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTVENC'	,'NMFILIALRECE'	,'Filial de Recebimento'	,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTVENC'	,'NMFANTFORN'	,'Nome Fantasia'		,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTVENC'	,'NMRAZSOCFORN'	,'Razo Social'			,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTAPAGDTVENC'	,'NMTIPOCONTA'	,'Tipo de Conta'		,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTAPAGDTVENC'	,'CDANOBI'	,'Ano'				,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTVENC'	,'CDMESBI'	,'Ms'				,NULL	  ,NULL		  ,NULL		  ,NULL);
	CRIA_DIME('DM_CONTAPAGDTVENC'	,'DSSTCONTA'	,'Situao da Conta'		,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTVENC'	,'STATUS'	,'Status'		,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTVENC'	,'DOC_SERIE'	,'Doc/Serie'		,NULL	  ,NULL		  ,NULL		  ,NULL);
    CRIA_DIME('DM_CONTAPAGDTVENC'	,'DESCRICAO'	,'Descrio'		,NULL	  ,NULL		  ,NULL		  ,NULL);
END;
/
	
-- VERSAO --
BEGIN ATUVEROBJ('DM_CONTAPAGDTVENC','5.09.105'); END;
/